欢迎关注更多精彩
关注我,学习常用算法与数据结构,一题多解,降维打击。
[[1691] 堆叠长方体的最大高度
给你 n 个长方体 cuboids ,其中第 i 个长方体的长宽高表示为 cuboids[i] = [widthi, lengthi, heighti](下标从 0 开始)。请你从 cuboids 选出一个 子集 ,并将它们堆叠起来。
如果 widthi <= widthj 且 lengthi <= lengthj 且 heighti <= heightj ,你就可以将长方体 i 堆叠在长方体 j 上。你可以通过旋转把长方体的长宽高重新排列,以将它放在另一个长方体上。
返回 堆叠长方体 cuboids 可以得到的 最大高度 。
示例 1:
输入:cuboids = [[50,45,20],[95,37,53],[45,23,12]]
输出:190
解释:
第 1 个长方体放在底部,53x37 的一面朝下,高度为 95 。
第 0 个长方体放在中间,45x20 的一面朝下,高度为 50 。
第 2 个长方体放在上面,23x12 的一面朝下,高度为 45 。
总高度是 95 + 50 + 45 = 190 。
示例 2:
输入:cuboids = [[38,25,45],[76,35,3]]
输出:76
解释:
无法将任何长方体放在另一个上面。
选择第 1 个长方体然后旋转它,使 35x3 的一面朝下,其高度为 76 。
示例 3:
输入:cuboids = [[7,11,17],[7,17,11],[11,7,17],[11,17,7],[17,7,11],[17,11,7]]
输出:102
解释:
重新排列长方体后,可以看到所有长方体的尺寸都相同。
你可以把 11x7 的一面朝下,这样它们的高度就是 17 。
堆叠长方体的最大高度为 6 * 17 = 102 。
提示:
n == cuboids.length
1 <= n <= 100
1 <= widthi, lengthi, heighti <= 100
此题为动态规划,可以结合贪心+模拟的思路解决,可以参考一下最长递增子序列那一题https://leetcode-cn.com/problems/longest-increasing-subsequence/。
总结一下思路如下
class Solution {
private:
int h[n][3]; // 存储dp结果
bool vis[n][3]; // 记忆标记
bool canPushOn(vector upCube, int upHeightInd, vector downCube, int downHeightInd) {
}
int dp(int i, int j, vector> &cuboids) {
if (vis[i][j]) return h[i][j];
vis[i][j] = true;
int topheight = 0;
// 查看其他箱子并尝试将其放到自己上头
for (int k = 0; k < cuboids.size(); ++k) {
for (int l = 0; l < 3; ++l) { // 以l为高放置
// 判断是否可以放在当前箱子上面
if (!canPushOn(cuboids[k], l, cuboids[i], j)) continue;
topheight = max(topheight, dp(k, l, cuboids));
}
}
h[i][j] = cuboids[i][j] + topheight;
return h[i][j];
}
public:
int maxHeight(vector> &cuboids) {
for (int i = 0; i < cuboids.size(); ++i) {
memset(vis[i], 0, sizeof(vis[i]));
}
int maxH = 0;
for (int i = 0; i < cuboids.size(); ++i) {
maxH = max(maxH, dp(i, 0, cuboids));
maxH = max(maxH, dp(i, 1, cuboids));
maxH = max(maxH, dp(i, 2, cuboids));
}
return maxH;
}
};
但是以上算法还有一个缺点,以[[1,1,1],[1,1,1]] 为例,可以发现运行这个例子的时候会存在循环,导致答案错误。
回想一下最长上升序列那题其实我们dp的方向都是向前的,也就是i是越来越小的。
那对于这一题来说只要2个三维体的长宽高不一样,那么这2者之间的上下关系是固定的。
举例说明一下
cube1 [a,b,c], cube2 [d,e,f] 其中 a
证明:如果cube1想放在cube2下面,那么首先要找到一条cube2边比a小,显然是不可能的。
有了以上结论我们可以先对所有的cube按照长宽高排序,我们规定高>宽>长。
然后从前往后遍历cube再去做dp。
这样也能解决我们之前说的2个相同规格箱子的case。
优化后的思路
class Solution {
private:
static bool Less1(vector &s1, vector &s2) {
}
int h[n][3]; // 存储dp结果
bool vis[n][3]; // 记忆标记
bool canPushOn(vector upCube, int upHeightInd, vector downCube, int downHeightInd) {
}
int dp(int i, int j, vector> &cuboids) {
if (vis[i][j]) return h[i][j];
vis[i][j] = true;
int topheight = 0;
// 查看其他箱子并尝试将其放到自己上头
for (int k = 0; k < i; ++k) {
for (int l = 0; l < 3; ++l) { // 以l为高放置
// 判断是否可以放在当前箱子上面
if (!canPushOn(cuboids[k], l, cuboids[i], j)) continue;
topheight = max(topheight, dp(k, l, cuboids));
}
}
h[i][j] = cuboids[i][j] + topheight;
return h[i][j];
}
public:
int maxHeight(vector> &cuboids) {
for (int i = 0; i < cuboids.size(); ++i) {
memset(vis[i], 0, sizeof(vis[i]));
}
int maxH = 0;
sort(cuboids.begin(), cuboids.end(), Less1);
for (int i = 0; i < cuboids.size(); ++i) {
maxH = max(maxH, dp(i, 0, cuboids));
maxH = max(maxH, dp(i, 1, cuboids));
maxH = max(maxH, dp(i, 2, cuboids));
}
return maxH;
}
};
class Solution {
private:
static bool Less1(vector &s1, vector &s2) {
sort(s1.begin(), s1.end());
sort(s2.begin(), s2.end());
for (int i = 0; i < 3; ++i) {
if (s1[i] < s2[i]) return true;
if (s1[i] > s2[i]) return false;
}
return false;
}
int h[n][3]; // 存储dp结果
bool vis[n][3]; // 记忆标记
void getLongWeight(vector &cube, int heightInd, int a[2]) {
for (int i = 0, j = 0; i < 3; ++i) {
if (i == heightInd)continue;
a[j++] = cube[i];
}
sort(a, a + 2); // 排序,使得小边与小边比,大边与大边比
}
bool canPushOn(vector upCube, int upHeightInd, vector downCube, int downHeightInd) {
if (upCube[upHeightInd] > downCube[downHeightInd]) return false; // 判断高度是否满足条件
// 采集剩下2边
int upLongeWeight[2], downLongeWeight[2];
getLongWeight(upCube, upHeightInd, upLongeWeight);
getLongWeight(downCube, downHeightInd, downLongeWeight);
// 判断条件
return upLongeWeight[0] <= downLongeWeight[0] && upLongeWeight[1] <= downLongeWeight[1];
}
int dp(int i, int j, vector> &cuboids) {
if (vis[i][j]) return h[i][j];
vis[i][j] = true;
int topheight = 0;
// 查看其他箱子并尝试将其放到自己上头
for (int k = 0; k < i; ++k) {
for (int l = 0; l < 3; ++l) { // 以l为高放置
// 判断是否可以放在当前箱子上面
if (!canPushOn(cuboids[k], l, cuboids[i], j)) continue;
topheight = max(topheight, dp(k, l, cuboids));
}
}
h[i][j] = cuboids[i][j] + topheight;
return h[i][j];
}
public:
int maxHeight(vector> &cuboids) {
for (int i = 0; i < cuboids.size(); ++i) {
memset(vis[i], 0, sizeof(vis[i]));
}
int maxH = 0;
sort(cuboids.begin(), cuboids.end(), Less1);
/*
for (int j = 0; j < cuboids.size(); ++j) {
for (int i = 0; i < 3; ++i) {
cout << cuboids[j][i] << ' ';
}
cout << endl;
}
*/
for (int i = 0; i < cuboids.size(); ++i) {
maxH = max(maxH, dp(i, 0, cuboids));
maxH = max(maxH, dp(i, 1, cuboids));
maxH = max(maxH, dp(i, 2, cuboids));
}
return maxH;
}
};